using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;

namespace GDBG_DisplayDataFromMultipleTables
{
	#region Class Form1 Description
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		#region Variable Declaration
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid gridDataBoundGrid1;
		
		private DataTable table1;
		private DataTable table2;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		///
		#endregion
		private System.ComponentModel.Container components = null;

		#region Form Constructor Initialization and Disposing 
		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
		#endregion

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridDataBoundGrid1 = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridDataBoundGrid1
			// 
			this.gridDataBoundGrid1.AllowDragSelectedCols = true;
			this.gridDataBoundGrid1.Location = new System.Drawing.Point(8, 16);
			this.gridDataBoundGrid1.Name = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.OptimizeInsertRemoveCells = true;
			this.gridDataBoundGrid1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.gridDataBoundGrid1.Size = new System.Drawing.Size(664, 240);
			this.gridDataBoundGrid1.SmartSizeBox = false;
			this.gridDataBoundGrid1.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
			this.gridDataBoundGrid1.TabIndex = 0;
			this.gridDataBoundGrid1.Text = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.UseListChangedEvent = true;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(688, 270);
			this.Controls.Add(this.gridDataBoundGrid1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		#region Main Function Definition
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
		#endregion

		#region Form Event Hanlder

		private void Form1_Load(object sender, System.EventArgs e)
		{
			table1 = GetTable1();
			table2 = GetTable2();
						
			this.gridDataBoundGrid1.DataSource = table1;
			this.gridDataBoundGrid1.EnableAddNew = false;
			this.gridDataBoundGrid1.ActivateCurrentCellBehavior = GridCellActivateAction.None;
			this.gridDataBoundGrid1.SortBehavior = GridSortBehavior.None;
			
			//use QueryCellInfo to bind the other
			this.gridDataBoundGrid1.Model.QueryCellInfo+=new Syncfusion.Windows.Forms.Grid.GridQueryCellInfoEventHandler(Model_QueryCellInfo);
			//if you want to edit your data in the grid, you need to 
			//handle saving data back to the data source...
			this.gridDataBoundGrid1.Model.SaveCellInfo+=new Syncfusion.Windows.Forms.Grid.GridSaveCellInfoEventHandler(Model_SaveCellInfo);
		
			
		}
		#endregion //Form Even Handler

		#region DataTable
		private DataTable GetTable1()
		{
			DataTable dt = new DataTable("Table1");

			int nCols = 4;
			int nRows = 5;

			for(int i = 0; i < nCols; i++)
				dt.Columns.Add(new DataColumn(string.Format("Col_1_{0}", i)));

			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt.NewRow();
				for(int j = 0; j < nCols; j++)
					dr[j] = string.Format("Cell1_{0}_{1}", i, j);
				dt.Rows.Add(dr);
			}
			return dt;
		}

		private DataTable GetTable2()
		{
			DataTable dt = new DataTable("Table2");

			int nCols = 4;
			int nRows = 5;

			for(int i = 0; i < nCols; i++)
				dt.Columns.Add(new DataColumn(string.Format("Col_2_{0}", i)));

			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt.NewRow();
				for(int j = 0; j < nCols; j++)
					dr[j] = string.Format("tableCell2_{0}_{1}", i, j);
				dt.Rows.Add(dr);
			}
			return dt;
		}
		#endregion//Datatable
		
		#region Grid Event Handler		
		//bind the both table using QueryCellInfo
		private void Model_QueryCellInfo(object sender, Syncfusion.Windows.Forms.Grid.GridQueryCellInfoEventArgs e)
		{
			if(e.ColIndex > 0 && e.RowIndex > 0)
			{
				GridModel model = sender as GridModel; 
				if( e.RowIndex > model.RowCount /2 )
					e.Style.CellValue = table1.Rows[e.RowIndex  -3 ][e.ColIndex -1];
				else 
					e.Style.CellValue = table2.Rows[e.RowIndex - 1 ][e.ColIndex -1];
				e.Handled = true;
				
			}			
		}

		private void Model_SaveCellInfo(object sender, Syncfusion.Windows.Forms.Grid.GridSaveCellInfoEventArgs e)
		{
			if(e.ColIndex > 0 && e.RowIndex > 0)
			{
				GridModel model = sender as GridModel; 
				if( e.RowIndex > model.RowCount /2 )
					table1.Rows[e.RowIndex  -3 ][e.ColIndex -1] = e.Style.CellValue;
				else 
					table2.Rows[e.RowIndex - 1 ][e.ColIndex -1]= e.Style.CellValue;
				
			}		
		}
		#endregion
	}		
	#endregion //Class Form1 Description
}
